#pragma once

#include <exception>

#include "esp_err.h"

// qthing public

namespace qthing {

class EspError : public std::exception {
 public:
  const esp_err_t errorNumber;
  EspError(esp_err_t errorNumber) : errorNumber(errorNumber) {}
  const char* what() const noexcept { return esp_err_to_name(errorNumber); }
};

void errorCodeToException(esp_err_t errorNumber);

}  // namespace qthing
