#include "qthing/mqtt_c.h"

#include "environment.h"
#include "qthing/mqtt_common.h"

esp_mqtt_client_handle_t mqtt_client_start_c(mqtt_event_callback_t mqtt_event_handler) {
  const esp_mqtt_client_config_t mqtt_cfg = {
#ifdef MQTT_URI
      .uri = MQTT_URI,
#else
      .host = MQTT_SERVER,
#endif
#ifdef MQTT_USE_GLOBAL_CA_STORE
      .use_global_ca_store = true,
#endif
      .event_handle = mqtt_event_handler,
      .lwt_topic = STATUS_TOPIC,
      .lwt_msg = STATUS_MESSAGE_OFFLINE,
      .lwt_msg_len = strlen(STATUS_MESSAGE_OFFLINE),
      .lwt_qos = 0,
      .lwt_retain = 1,
      .keepalive = 60,
  };

  esp_mqtt_client_handle_t client = esp_mqtt_client_init(&mqtt_cfg);
  esp_mqtt_client_start(client);
  return client;
}
